NOTE: build for oea-dev, replace build-args in build command accordingly for other environments

TODO: Incorporate this file's contents into the top-level README.md

TODO: unifiy handling of these env vars if possible:

* FRONTEND_SERVER_BASE_URL (needed at build-time (nuxt!)) is read by oeaplatform/frontend-server/app.js; falls back to: https://portal.openeducation.at and is set at image build time (see --build-arg below)
* INDEX_BASE_URL (from docker-compose.yml) is read by oeaplatform/frontend-client/nuxt.config.js and is set at runtime (by docker-compose.yml for example)

`baseURL` in `frontend-client/utils/HTTPRequest.js` references the URL where the frontend's server component is reached. This is still
hardcoded in that file
```
DOCKER_REGISTRY=localhost:5443
TAG=`date +%Y-%m-%dT%H.%M.%S`
```

### Build (new) frontend

```
docker-compose build \
    --no-cache \
    --build-arg FRONTEND_SERVER_BASE_URL=https://oea-sandbox.univie.ac.at \
    --build-arg NODE_ENV=production \
    frontend-server \
    frontend-client
```

### Tag as is customary

```

ID=`docker images -q $DOCKER_REGISTRY/frontend-client:focal_stable` && docker tag $ID frontend-client:$TAG
ID=`docker images -q $DOCKER_REGISTRY/frontend-server:focal_stable` && docker tag $ID frontend-server:$TAG
```

### Push to registry

```
docker push $DOCKER_REGISTRY/frontend-client:focal_stable
docker push $DOCKER_REGISTRY/frontend-server:focal_stable
```

### Deploy

```
docker stack deploy --with-registry-auth -c docker-compose.yml oeaplatform
```
