import httpRequest from '~/utils/HTTPRequest'
export const strict = false

export const state = () => ({
  size: 10,
  currentPage: 0,
  query: '',
  fixedQuery: '',
  totalResults: 0,
  numOfPages: 0,
  formatedPages: [],
  results: [],
  isSearching: false,
  isLoading: false,
  disciplines: [],
  filteredDisciplines: [],
  selectedDisciplines: [],
  learningRTs: [],
  filteredLearningRTs: [],
  selectedLearningRTs: [],
  languages: [],
  filteredLanguages: [],
  selectedLanguages: [],
  licences: [],
  selectedLicences: [],
  mediaTypes: [],
  selectedMediaTypes: [],
  sources: [],
  selectedSources: [],
  selectedDateRange: '',
  documentData: false,
  sortType: '',
  sortOrder: '',
  sortinDescription: '',
  sortinLearningRT: '',
  favorites: [],
  favoritesData: [],
  startDate: '',
  endDate: '',
  modal: '',
  startItem: '',
  endItem: '',
})

export const mutations = {
  resetFilters(state, _) {
    state.selectedDisciplines = []
    state.selectedLearningRTs = []
    state.selectedLanguages = []
    state.selectedLicences = []
    state.selectedDateRange = ''
    state.selectedSources = []
    state.selectedMediaTypes = []
    state.size = 10
    state.currentPage = 0
    state.startDate = ''
    state.endDate = ''
    state.startItem = ''
    state.endItem = ''
  },
  changeSize(state, payload) {
    state.size = payload
  },
  changeCurrentPage(state, payload) {
    state.currentPage = payload
  },
  changeQuery(state, payload) {
    state.query = payload
  },
  changeTotalResults(state, payload) {
    state.totalResults = payload
  },
  changeStartItem(state, payload) {
    state.startItem = payload
  },  
  changeEndItem(state, payload) {
    state.endItem = payload
  },  
  changeNumOfPages(state, payload) {
    state.numOfPages = payload
  },
  changeResults(state, payload) {
    state.results = [...payload]
  },
  changeIsSearching(state, payload) {
    state.isSearching = payload
  },
  changeIsLoading(state, payload) {
    state.isLoading = payload
  },
  changeDisciplines(state, payload) {
    state.disciplines = payload
  },
  changeLearningRTs(state, payload) {
    state.learningRTs = payload
  },
  changeLanguages(state, payload) {
    state.languages = payload
  },
  changeFilteredDisciplines(state, payload) {
    state.filteredDisciplines = payload
  },
  changeFilteredLearningRTs(state, payload) {
    state.filteredLearningRTs = payload
  },
  changeFilteredLanguages(state, payload) {
    state.filteredLanguages = payload
  },
  changeSelectedDisciplines(state, payload) {
    state.selectedDisciplines = payload
  },
  changeSelectedLearningRTs(state, payload) {
    state.selectedLearningRTs = payload
  },
  changeSelectedLanguages(state, payload) {
    state.selectedLanguages = payload
  },
  changeLicences(state, payload) {
    state.licences = payload
  },
  changeSelectedLicences(state, payload) {
    state.selectedLicences = payload
  },
  changeMediaTypes(state, payload) {
    state.mediaTypes = payload
  },
  changeSelectedMediaTypes(state, payload) {
    state.selectedMediaTypes = payload
  },
  changeSources(state, payload) {
    state.sources = payload
  },
  changeSelectedSources(state, payload) {
    state.selectedSources = payload
  },
  changeSelectedDateRange(state, payload) {
    state.selectedDateRange = payload
  },
  changeDocumentData(state, payload) {
    state.documentData = payload
  },
  changeFixedQuery(state, payload) {
    state.fixedQuery = payload
  },
  changeSortType(state, payload) {
    state.sortType = payload
  },
  changeSortOrder(state, payload) {
    state.sortOrder = payload
  },
  changeSortingDescription(state, payload) {
    state.sortingDescription = payload
  },
  resetSort(state, _) {
    state.sortType = ''
    state.sortOrder = ''
  },
  fetchFavorites(state, _) {
    const favorites = JSON.parse(window.localStorage.getItem('favorites')) || []
    state.favorites = [...favorites]
  },
  changeFavorites(state, payload) {
    const favorites = JSON.parse(window.localStorage.getItem('favorites')) || []
    const index = favorites.indexOf(payload)
    if (index !== -1) {
      favorites.splice(index, 1)
    } else favorites.push(payload)
    state.favorites = favorites
    window.localStorage.setItem('favorites', JSON.stringify(favorites))
  },
  changeFavoritesData(state, payload) {
    state.favoritesData = payload
  },
  changeStartDate(state, payload) {
    state.startDate = payload
  },
  changeEndDate(state, payload) {
    state.endDate = payload
  },
  changeModal(state, payload) {
    state.modal = payload
  },
  formatPages(state, _) {
    state.formatPages = []
    const current = state.currentPage
    const last = state.numOfPages
    const delta = 2
    const left = current - delta + 1
    const right = current + delta + 1
    const range = []
    const rangeWithDots = []
    let l

    for (let i = 1; i <= last; i++) {
      if (i === 1 || i === last || (i >= left && i < right)) {
        range.push(i)
      }
    }

    for (const i of range) {
      if (l) {
        if (i - l === 2) {
          rangeWithDots.push(l + 1)
        } else if (i - l !== 1) {
          rangeWithDots.push('...')
        }
      }
      rangeWithDots.push(i)
      l = i
    }

    state.formatedPages = rangeWithDots
  },
}
