#!/usr/bin/env perl

use strict;
use warnings;

use Data::Dumper;

use FindBin;
use Test::More;

use utf8;

my $tree = {
# 'file' => <0:skip|1:test>,
  'daemon.pl' => 1,
  'lib/App.pm' => 1,
  'lib/App/Logger.pm' => 1,
  'lib/App/Type/Openlib.pm' => 1,
  'lib/App/Type/Phaidra.pm' => 1,
  'lib/App/Type/OAIIngest_DC.pm' => 1,
  'lib/App/Type/LOMIngest_general.pm' => 1,
  'lib/App/Type/LOMIngest_invenio.pm' => 1,
  'lib/App/Type/LOMIngest_edusharing.pm' => 1,
  'lib/App/Type/OAIIngest_LOM_invenio.pm' => 1,
  'lib/App/Type/OAIIngest_LOM_edusharing.pm' => 1,
  'lib/App/Type/dummy.pm' => 1,
};
my $dir = "$FindBin::Bin/..";

SCRIPT:
for my $script ( keys %$tree ) {
  next SCRIPT unless $tree->{ $script };
  my $file = "$dir/$script";
  my $res;
  eval {
    $res = `perl -c $file 2>&1`;
    chomp $res;
  };
  is( $res, "$file syntax OK", "$file compiled" );
}

done_testing();

exit(0);

